﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Windows.Forms;

namespace ScenarioCacheViewer
{
    public partial class Form1 : Form
    {
        string ApplicationFolder;

        public DataTable ScenarioCacheDt = new DataTable();
        public DataTable StringCacheDt = new DataTable();

        public static readonly string Variant_CWN = "CardWirthNext.exe";
        public static readonly string Variant_CW = "CardWirth.exe";
        public static readonly string Variant_CW256 = "CardWirth_256.exe";
        public static readonly string Variant_Oedo = "OedoWirth.exe";
        public static readonly string Variant_Modern = "ModernWirth.exe";
        public static readonly string Variant_School = "S_C_Wirth.exe";
        public static readonly string Variant_Dark = "DarkWirth.exe";
        public static readonly string Variant_gs = "CardWirth_gs.exe";
        public static readonly string Variant_CW_Vip = "CW#Vip_N.exe";
        public static readonly string Variant_CW_MP = "CWMP.exe";
        public static readonly string Variant_CW_AP = "CardWirth_AP.exe";
        public static readonly string Variant_CWD_STD = "CW´Standard.exe";
        public static readonly string Variant_CWD_HERO = "CW´Heroic.exe";
        public static readonly string Variant_CWD_COMN = "CW´Commoner.exe";

        // バリアント種類
        public static バリアント種類 variant = バリアント種類.中世ファンタジーⅠ型;

        public static string VariantExe = ".\\CardWirth.exe";

        private string[] ColumnNames = 
            {
                "Scenario",
                "Author",
                "Low",
                "High",
                "Version",
                "CanPlay",
                "Expression",
                "Folder",
                "LastWrite",
                "Coupon1",
                "Coupon2",
                "Coupon3",
                "Coupon4",
                "Coupon5"
            };

        private string[] Captions = 
            {
                "シナリオ名",
                "作者名",
                "Low",
                "High",
                "Ver",
                "プレイ可能？",
                "解説",
                "フォルダ",
                "更新日時",
                "必要クーポン１",
                "必要クーポン２",
                "必要クーポン３",
                "必要クーポン４",
                "必要クーポン５"
            };


        private string[] ColumnNames2 = 
            {
                "Name",
                "Type",
                "Scenario",
                "File",
                "StartName",
                "ContentName"
            };

        private string[] Captions2 = 
            {
                "名前",
                "タイプ",
                "シナリオ名",
                "ファイル名",
                "スタート",
                "コンテント"
            };

        public enum バリアント種類
        {
            中世ファンタジーⅠ型,
            大江戸,
            現代Ⅰ型,
            学園,
            妖魔
        }
        public Form1()
        {
            InitializeComponent();

#if DEBUG
            //ApplicationFolder = @"C:\CardWirth_AP";
            ApplicationFolder = @"C:\CardWirth_AP";
#else
            ApplicationFolder = System.Windows.Forms.Application.StartupPath;
#endif
            CheckVariant();


        }


        /// <summary>
        /// バリアントチェック
        /// </summary>
        private void CheckVariant()
        {
            // 同じフォルダにあるバリアントチェック
            if (File.Exists(ApplicationFolder + "\\"
                + CWData.Variant_CW_AP))
            {
                // CardWirth_AP.exe
                variant = バリアント種類.中世ファンタジーⅠ型;
                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_CW_AP;
            }
            else if (File.Exists(ApplicationFolder
                + "\\" + CWData.Variant_CW256))
            {
                // CardWirth_256.exe
                variant = バリアント種類.中世ファンタジーⅠ型;
                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_CW256;
            }
            else if (File.Exists(ApplicationFolder
                + "\\" + CWData.Variant_CW_Vip))
            {
                // CW#Vip_N.exe
                variant = バリアント種類.中世ファンタジーⅠ型;
                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_CW_Vip;
            }
            else if (File.Exists(ApplicationFolder
                + "\\" + CWData.Variant_CW_MP))
            {
                // CWMP.exe
                variant = バリアント種類.中世ファンタジーⅠ型;
                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_CW_MP;
            }
            else if (File.Exists(ApplicationFolder
                + "\\" + CWData.Variant_CW))
            {
                // SFバリアントはexe名とデータ構造が同じなので
                // 今のところ中世Ⅰ型として扱う
                variant = バリアント種類.中世ファンタジーⅠ型;
                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_CW;
            }
            else if (File.Exists(ApplicationFolder
                + "\\" + CWData.Variant_Oedo))
            {
                variant = バリアント種類.大江戸;

                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_Oedo;
            }
            else if (File.Exists(ApplicationFolder
                + "\\" + CWData.Variant_Modern))
            {
                variant = バリアント種類.現代Ⅰ型;
                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_Modern;
            }
            else if (File.Exists(ApplicationFolder
                + "\\" + CWData.Variant_School))
            {
                variant = バリアント種類.学園;
                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_School;
            }
            else if (File.Exists(ApplicationFolder
                + "\\" + CWData.Variant_Dark))
            {
                variant = バリアント種類.妖魔;
                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_Dark;
            }
            else if (File.Exists(ApplicationFolder
                + "\\" + CWData.Variant_gs))
            {
                // グリマスポットバリアントは
                // バリアントの種類としてはCWエンジンと変わらないので
                variant = バリアント種類.中世ファンタジーⅠ型;
                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_gs;
            }
            else if (File.Exists(ApplicationFolder
                    + "\\" + CWData.Variant_CWD_STD))
            {
                // CW´は
                // バリアントの種類としてはCWエンジンと変わらないので
                variant = バリアント種類.中世ファンタジーⅠ型;
                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_CWD_STD;
            }
            else if (File.Exists(ApplicationFolder
               + "\\" + CWData.Variant_CWD_HERO))
            {
                // CW´は
                // バリアントの種類としてはCWエンジンと変わらないので
                variant = バリアント種類.中世ファンタジーⅠ型;
                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_CWD_HERO;
            }
            else if (File.Exists(ApplicationFolder
               + "\\" + CWData.Variant_CWD_COMN))
            {
                // CW´は
                // バリアントの種類としてはCWエンジンと変わらないので
                variant = バリアント種類.中世ファンタジーⅠ型;
                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_CWD_COMN;
            }
            else if (File.Exists(ApplicationFolder + "\\"
                + CWData.Variant_CWN))
            {
                // CardWirthNext.exe
                variant = バリアント種類.中世ファンタジーⅠ型;
                VariantExe = ApplicationFolder
                    + "\\" + CWData.Variant_CWN;
            }
            else
            {
                if (!File.Exists(VariantExe))
                {
                    MessageBox.Show("CardWirthフォルダではありません。\n" +
                        VariantExe);
                    Application.Exit();
                }
            }
        }
        private void Form1_Load(object sender, EventArgs e)
        {

            this.cmbSearch1.Items.Add("シナリオ名");
            this.cmbSearch1.Items.Add("作者名");
            this.cmbSearch1.Items.Add("解説");
            this.cmbSearch1.Items.Add("フォルダ");
            this.cmbSearch1.SelectedIndex = 0;

            this.cmbSearch2.Items.Add("シナリオ名");
            this.cmbSearch2.Items.Add("作者名");
            this.cmbSearch2.Items.Add("解説");
            this.cmbSearch2.Items.Add("フォルダ");
            this.cmbSearch2.SelectedIndex = 1;

            this.txtSearch1.Select();

            this.cmbSearch3.Items.Add("クーポン");
            this.cmbSearch3.Items.Add("ゴシップ");
            this.cmbSearch3.SelectedIndex = 0;
            
            this.txtSearch3.Select();

        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            if (File.Exists(ApplicationFolder + "\\Summary.cache"))
            {
                // デシリアライズしてDataTable取り出し
                ReadCache();
            }
            else
            {
                PrepareNewDt();
            }

            if (File.Exists(ApplicationFolder + "\\String.cache"))
            {
                // デシリアライズしてDataTable取り出し
                ReadCache2();
            }
            else
            {
                PrepareNewDt2();
            }

            DispDt();
            DispDt2();
        }

        public void ReadCache()
        {
            //読み込んでデシリアライズする
            FileStream fs = new FileStream(ApplicationFolder + "\\Summary.cache",
            FileMode.Open,
            FileAccess.Read);
            BinaryFormatter f = new BinaryFormatter();

            // ダイアログを出すほどの時間がかからない

            object obj = f.Deserialize(fs);
            DataSet ds = (DataSet)obj;
            ScenarioCacheDt = ds.Tables[0];

            f = null;
            fs.Dispose();

        }

        public void ReadCache2()
        {
            //読み込んでデシリアライズする
            FileStream fs = new FileStream(ApplicationFolder + "\\String.cache",
            FileMode.Open,
            FileAccess.Read);
            BinaryFormatter f = new BinaryFormatter();

            // ダイアログを出すほどの時間がかからない

            try
            {
                object obj = f.Deserialize(fs);
                DataSet ds = (DataSet)obj;
                StringCacheDt = ds.Tables[0];

                f = null;
                fs.Dispose();
            }
            catch (Exception)
            {
                PrepareNewDt2();
            }
        }

        private void PrepareNewDt()
        {
            ScenarioCacheDt = new DataTable();

            ScenarioCacheDt.CaseSensitive = true;

            //DataColumn 設定
            DataColumn dataCol;


            for (int i = 0; i < ColumnNames.Length; i++)
            {
                dataCol = new DataColumn();
                dataCol.ColumnName = ColumnNames[i];
                dataCol.Caption = Captions[i];
                if (i > 4 || i < 2)
                {
                    dataCol.DataType = typeof(string);
                    dataCol.DefaultValue = string.Empty;
                }
                else if (i == 3)
                {
                    dataCol.DataType = typeof(int);
                    dataCol.DefaultValue = 999;
                }
                else
                {
                    dataCol.DataType = typeof(int);
                    dataCol.DefaultValue = 0;
                }

                ScenarioCacheDt.Columns.Add(dataCol);
            }

        }

        private void PrepareNewDt2()
        {
            StringCacheDt = new DataTable();

            StringCacheDt.CaseSensitive = true;

            //DataColumn 設定
            DataColumn dataCol;
            for (int i = 0; i < ColumnNames2.Length; i++)
            {
                dataCol = new DataColumn();
                dataCol.ColumnName = ColumnNames2[i];
                dataCol.Caption = Captions2[i];

                dataCol.DataType = typeof(string);
                dataCol.DefaultValue = string.Empty;

                StringCacheDt.Columns.Add(dataCol);
            }

        }

        bool widthFirst = false;
        private void DispDt()
        {
            DataTable dtDisp = ScenarioCacheDt.Copy();
            int dtCount = dtDisp.Rows.Count;

            DataView dv = new DataView(dtDisp);
            //  検索１
            string search1Type = string.Empty;
            switch (cmbSearch1.SelectedIndex)
            {
                case 0:
                    search1Type = ColumnNames[0];
                    break;
                case 1:
                    search1Type = ColumnNames[1];
                    break;
                case 2:
                    search1Type = ColumnNames[6];
                    break;
                default:
                    search1Type = ColumnNames[7];
                    break;
            }

            string likeWord = txtSearch1.Text;
            if (likeWord.IndexOf("'") > -1)
            {
                MessageBox.Show("'抜きで検索してください。");
                this.txtSearch1.Focus();
                return;
            }

            string search1Filter = likeWord.Equals(string.Empty)
                ? string.Empty
                : search1Type + " LIKE '%" + likeWord + "%'";


            //  検索２
            string search2Type = string.Empty;
            switch (cmbSearch2.SelectedIndex)
            {
                case 0:
                    search2Type = ColumnNames[0];
                    break;
                case 1:
                    search2Type = ColumnNames[1];
                    break;
                case 2:
                    search2Type = ColumnNames[6];
                    break;
                default:
                    search2Type = ColumnNames[7];
                    break;
            }

            likeWord = txtSearch2.Text;
            if (likeWord.IndexOf("'") > -1)
            {
                MessageBox.Show("'抜きで検索してください。");
                this.cmbSearch2.Focus();
                return;
            }

            string search2Filter = likeWord.Equals(string.Empty)
                ? string.Empty
                : search2Type + " LIKE '%" + likeWord + "%'";

            // レベル
            string levelFilter = string.Empty;

            int levelLow = 0;
            int levelHigh = 0;
            bool setLow = false;
            bool setHigh = false;
            setLow = int.TryParse(txtLevelLow.Text, out levelLow);
            setHigh = int.TryParse(txtLevelHigh.Text, out levelHigh);

            if (setLow)
            {
                if (setHigh)
                {
                    // 両方入っている
                    if (levelLow > levelHigh)
                    {
                        // 表示するものがない
                        levelFilter = "1 = 2";

                    }
                    else
                    {

                        levelFilter =
                            "( Low >= " + levelLow + " AND Low <= " + levelHigh
                            + ") OR ( High >= " + levelLow + " AND High <= " + levelHigh
                            + ") OR ( Low < " + levelLow + " AND High > " + levelHigh + ")";
                    }
                }
                else
                {
                    //Lowのみ
                    levelFilter = "High >= " + levelLow;

                }
            }
            else
            {
                if (setHigh)
                {
                    //Highのみ
                    levelFilter = "Low <= " + levelHigh;
                }
                else
                {
                    //どちらもないのでそのまま
                }

            }

            dv.RowFilter = string.Empty;
            dv.RowFilter = StringConcateAnd(dv.RowFilter, search1Filter);
            dv.RowFilter = StringConcateAnd(dv.RowFilter, search2Filter);
            dv.RowFilter = StringConcateAnd(dv.RowFilter, levelFilter);

            int dvCount = dv.Count;

            dgv1.DataSource = dv;

            lblCount.Text = dvCount + "/" + dtCount;

            if (!widthFirst)
            {
                dgv1.Columns[ColumnNames[0]].Width = 140;
                dgv1.Columns[ColumnNames[1]].Width = 90;
                dgv1.Columns[ColumnNames[2]].Width = 40;
                dgv1.Columns[ColumnNames[3]].Width = 40;
                dgv1.Columns[ColumnNames[4]].Width = 40;
                dgv1.Columns[ColumnNames[5]].Visible = false;
                //dgv1.Columns[ColumnNames[5]].Width = 100;
                dgv1.Columns[ColumnNames[6]].Width = 400;
                dgv1.Columns[ColumnNames[7]].Width = 600;
                dgv1.Columns[ColumnNames[8]].Width = 120;
                widthFirst = true;
            }

            for (int i = 0; i < ScenarioCacheDt.Columns.Count; i++)
            {
                dgv1.Columns[i].HeaderText =
                    ScenarioCacheDt.Columns[i].Caption;
            }

            this.Activate();
        }

        private string StringConcateAnd(string baseStr, string addStr)
        {
            if (!baseStr.Equals(string.Empty))
            {
                if (!addStr.Equals(string.Empty))
                {
                    return baseStr + " AND " + addStr;
                }
                else
                {
                    return baseStr;
                }
            }
            else
            {
                return addStr;
            }
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            DispDt();
        }

        private void btnMake_Click(object sender, EventArgs e)
        {
            MakeCache();
            DispDt();
        }

        private void MakeCache()
        {

            // 新規DT、Column設定
            PrepareNewDt();

            DirectoryInfo di = new DirectoryInfo(ApplicationFolder + "\\Scenario");
            FileInfo[] fis = di.GetFiles("*.wsm", SearchOption.AllDirectories);

            int countMax = fis.Length;

            if (countMax != 0)
            {
                // summary ファイルを読み込みながら
                // DataRow追加しながらデータ格納

                int count = 0;
                SimpleSummaryData summary = null;
                DataRow dr;

                foreach (FileInfo fi in fis)
                {

                    try
                    {
                        summary = new SimpleSummaryData();
                        summary.Read(fi.FullName);

                        dr = ScenarioCacheDt.NewRow();

                        dr[ColumnNames[0]] = summary.ScenarioName;
                        dr[ColumnNames[1]] = summary.Author;
                        dr[ColumnNames[2]] = Convert.ToInt32(summary.LevelLow);
                        dr[ColumnNames[3]] = Convert.ToInt32(summary.LevelHigh);
                        dr[ColumnNames[4]] = Convert.ToInt32(summary.Version);


                        dr[ColumnNames[6]] = summary.ScenarioExpression;
                        dr[ColumnNames[7]] = Path.GetDirectoryName(fi.FullName);
                        dr[ColumnNames[8]] = fi.LastWriteTime.ToString();

                        // NeedCouponCountとNeedCoupons.Countが違うデータがある。
                        for (int i = 0; i < summary.NeedCoupons.Count && i < 5; i++)
                        {
                            dr[ColumnNames[9 + i]] = summary.NeedCoupons[i];
                        }

                        ScenarioCacheDt.Rows.Add(dr);

                    }
                    catch (Exception)
                    {
                        // 隊長！ファイル読み込めません！！
                    }

                    count += 1;
                }

                DataSet ds = new DataSet();
                ds.Tables.Add(ScenarioCacheDt);

                FileStream fs = new FileStream(
                ApplicationFolder + "\\Summary.cache",
                FileMode.Create,
                FileAccess.Write);
                BinaryFormatter bf = new BinaryFormatter();
                //シリアル化して書き込む
                bf.Serialize(fs, ds);
                fs.Close();
                fs.Dispose();

            }
            else
            {
                MessageBox.Show(
                    "シナリオがありません。");
            }
        }

        private void Form1_Resize(object sender, EventArgs e)
        {

            if (this.Width >= 640
                && this.Height >= 480)
            {
                this.tabControl1.Width = this.Width - 13;
                this.tabControl1.Height = this.Height - 36;
                
                this.dgv1.Width = this.Width - 30;
                this.dgv1.Height = this.Height - 120;

                this.dgv2.Width = this.Width - 30;
                this.dgv2.Height = this.Height - 120;

                this.lblCount.Location =
                    new Point(this.lblCount.Location.X, this.tabControl1.Height - 45);
                this.lblCount2.Location =
                    new Point(this.lblCount2.Location.X, this.tabControl1.Height - 45);
                
            }
        }

        bool widthFirst2 = false;
        private void DispDt2()
        {
            DataTable dtDisp = StringCacheDt.Copy();
            int dtCount = dtDisp.Rows.Count;

            DataView dv = new DataView(dtDisp);
            //  検索１
            string search3Type = string.Empty;
            search3Type = ColumnNames2[0];

            string likeWord = txtSearch3.Text;
            if (likeWord.IndexOf("'") > -1)
            {
                MessageBox.Show("'抜きで検索してください。");
                this.txtSearch3.Focus();
                return;
            }

            string search3Filter = likeWord.Equals(string.Empty)
                ? string.Empty
                : search3Type + " LIKE '%" + likeWord + "%'";


            string search4Filter = "";
            switch (cmbSearch3.SelectedIndex)
            {
                case 0:
                    search4Filter = ColumnNames2[1] + " LIKE " + "'クーポン'";
                    break;
                default:
                    search4Filter = ColumnNames2[1] + " LIKE " + "'ゴシップ'";
                    break;
            }

            dv.RowFilter = string.Empty;
            dv.RowFilter = StringConcateAnd(dv.RowFilter, search3Filter);
            dv.RowFilter = StringConcateAnd(dv.RowFilter, search4Filter);

            int dvCount = dv.Count;

            dgv2.DataSource = dv;
            lblCount2.Text = dvCount + "/" + dtCount;

            if (!widthFirst2)
            {
                dgv2.Columns[ColumnNames2[0]].Width = 140;
                dgv2.Columns[ColumnNames2[1]].Width = 90;
                dgv2.Columns[ColumnNames2[2]].Width = 600;
                dgv2.Columns[ColumnNames2[3]].Width = 140;
                dgv2.Columns[ColumnNames2[4]].Width = 140;
                dgv2.Columns[ColumnNames2[5]].Width = 140;
                widthFirst2 = true;
            }

            for (int i = 0; i < StringCacheDt.Columns.Count; i++)
            {
                dgv2.Columns[i].HeaderText =
                    StringCacheDt.Columns[i].Caption;
            }

            this.Activate();
        }


        private void btnSearch2_Click(object sender, EventArgs e)
        {
            DispDt2();
        }

        private void btnMake2_Click(object sender, EventArgs e)
        {
            MakeCache2();
            DispDt2();
        }

        private void MakeCache2()
        {
            // 新規DT、Column設定
            PrepareNewDt2();

            WidArea area = null;
            WidBattle battle = null;
            WidPackage pack = null;
            foreach (DataRow dr in ScenarioCacheDt.Rows)
            {
                string folder = dr[ColumnNames[7]].ToString();

                try
                {
                    DirectoryInfo di = new DirectoryInfo(folder);
                    FileInfo[] fis;
                    try
                    {
                        fis = di.GetFiles("Area*.wid", SearchOption.TopDirectoryOnly);
                        foreach (FileInfo fi in fis)
                        {
                            try
                            {
                                area = new WidArea();
                                area.Read(fi.FullName);
                                List<string> val = area.StringInfo();
                                foreach (string cont in val)
                                {
                                    string[] values = cont.Split(':');
                                    DataRow drr = StringCacheDt.NewRow();
                                    drr[0] = values[0];
                                    drr[1] = (values[2] == ContentType.BranchCoupon.ToString() ||
                                        values[2] == ContentType.GetCoupon.ToString() ||
                                        values[2] == ContentType.LostCoupon.ToString()) ?
                                        "クーポン" : "ゴシップ";
                                    drr[2] = folder;
                                    drr[3] = fi.Name;
                                    drr[4] = values[1];
                                    drr[5] = values[2];
                                    StringCacheDt.Rows.Add(drr);
                                }

                            }
                            catch (Exception)
                            {
                                // 隊長！ファイル読み込めません！！
                                continue;
                            }
                        }


                    }
                    catch (Exception)
                    {
                        // 隊長！ファイル読み込めません！！
                    }

                    try
                    {
                        fis = di.GetFiles("Battle*.wid", SearchOption.TopDirectoryOnly);

                        foreach (FileInfo fi in fis)
                        {
                            try
                            {
                                battle = new WidBattle();
                                battle.Read(fi.FullName);
                                List<string> val = battle.StringInfo();
                                foreach (string cont in val)
                                {
                                    string[] values = cont.Split(':');
                                    DataRow drr = StringCacheDt.NewRow();
                                    drr[0] = values[0];
                                    drr[1] = (values[2] == ContentType.BranchCoupon.ToString() ||
                                        values[2] == ContentType.GetCoupon.ToString() ||
                                        values[2] == ContentType.LostCoupon.ToString()) ?
                                        "クーポン" : "ゴシップ";
                                    drr[2] = folder;
                                    drr[3] = fi.Name;
                                    drr[4] = values[1];
                                    drr[5] = values[2];
                                    StringCacheDt.Rows.Add(drr);
                                }

                            }
                            catch (Exception)
                            {
                                // 隊長！ファイル読み込めません！！
                                continue;
                            }
                        }

                    }
                    catch (Exception)
                    {
                        // 隊長！ファイル読み込めません！！
                    }

                    try
                    {
                        fis = di.GetFiles("Package*.wid", SearchOption.TopDirectoryOnly);

                        foreach (FileInfo fi in fis)
                        {
                            try
                            {
                                pack = new WidPackage();
                                pack.Read(fi.FullName);
                                List<string> val = pack.StringInfo();
                                foreach (string cont in val)
                                {
                                    string[] values = cont.Split(':');
                                    DataRow drr = StringCacheDt.NewRow();
                                    drr[0] = values[0];
                                    drr[1] = (values[2] == ContentType.BranchCoupon.ToString() ||
                                        values[2] == ContentType.GetCoupon.ToString() ||
                                        values[2] == ContentType.LostCoupon.ToString()) ?
                                        "クーポン" : "ゴシップ";
                                    drr[2] = folder;
                                    drr[3] = fi.Name;
                                    drr[4] = values[1];
                                    drr[5] = values[2];
                                    StringCacheDt.Rows.Add(drr);
                                }
                            }
                            catch (Exception)
                            {
                                // 隊長！ファイル読み込めません！！
                                continue;
                            }
                        }

                    }
                    catch (Exception)
                    {
                        // 隊長！ファイル読み込めません！！
                    }

                }
                catch (Exception)
                {
                    // 隊長！ファイル読み込めません！！
                    continue;
                }
            }

            try
            {
                DataSet ds = new DataSet();
                ds.Tables.Add(StringCacheDt);

                FileStream fs = new FileStream(
                ApplicationFolder + "\\String.cache",
                FileMode.Create,
                FileAccess.Write);
                BinaryFormatter bf = new BinaryFormatter();
                //シリアル化して書き込む
                bf.Serialize(fs, ds);
                fs.Close();
                fs.Dispose();
            }
            catch (Exception)
            {
                MessageBox.Show("キャッシュは多すぎて作成できませんでした。");
            }
        }
    }
}
