
using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace ScenarioCacheViewer
{
    public class WidPackage : DataWithIO
    {
        #region tB[h
        uint version;
        string name;
        uint number;
        List<EventData> eventList;
        #endregion

        #region vpeB
        public uint Version
        {
            get { return version; }
            set { version = value; }
        }
        public string PackageName
        {
            get { return name; }
            set { name = value; }
        }
        public uint PackageNumber
        {
            get { return number; }
            set { number = value; }
        }
        public List<EventData> Events
        {
            get
            {
                if (eventList == null)
                    eventList = new List<EventData>();
                return eventList;
            }
        }
        #endregion

        #region [hCg
        public override void Read(BinaryReader r)
        {
            version = r.ReadUInt32();
            name = r.ReadString();
            number = r.ReadUInt32();
            uint count = r.ReadUInt32();
            EventData ev;
            for (; count > 0; count--)
            {
                ev = new EventData(false);
                ev.Read(r);
                Events.Add(ev);
            }
        }
        public override void Write(BinaryWriter w)
        {
            w.Write(version);
            w.Write(name);
            w.Write(number);
            w.Write(Events.Count);
            foreach (EventData e in Events)
                e.Write(w);
        }
        #endregion

        #region \bh

        List<string> ret = new List<string>();
        /// <summary>
        /// 񌟍
        /// </summary>
        /// <returns></returns>
        public List<string> StringInfo()
        {
            foreach (EventData ev in this.Events)
            {
                foreach (ContentData start in ev.Starts)
                {
                    CheckString(start.Children, start.Choice);
                }
            }

            return ret;
        }

        private void CheckString(List<ContentData> contents, string startText)
        {
            List<string> lst = new List<string>();
            foreach (ContentData content in contents)
            {
                if (content.ContentKind == ContentType.GetCoupon ||
                    content.ContentKind == ContentType.LostCoupon ||
                    content.ContentKind == ContentType.BranchCoupon ||
                    content.ContentKind == ContentType.GetGossip ||
                    content.ContentKind == ContentType.LostGossip ||
                    content.ContentKind == ContentType.BranchGossip)
                {
                    ret.Add(content.Data.StringData + ":" + startText + ":" + content.ContentKind.ToString());
                }

                if (content.Children.Count == 0) continue;

                CheckString(content.Children, startText);
            }

        }
        #endregion
    }//class WidPackage
}
